package bcho.tracer.aspectj.aspects;

import bcho.tracer.logging.Logger;
import bcho.tracer.logging.simplelogger.TextLogger;


public abstract aspect TracerAspectStarter {
	pointcut targetClass() : within(bcho.sample..*) ;
	pointcut targetMethod() : targetClass() && execution(* main(..));

	Logger logger = new TextLogger();
	
	String getThreadName(){
		return Thread.currentThread().getName();
	}
	before():targetMethod(){
		// initiate transaction id
		// Format [ System time-Thread Name ]
		
		String starterName 
			= thisJoinPoint.getSignature().getDeclaringType().getName();
		//= thisJoinPoint.getSignature().getClass().getName();
		
		StringBuffer txId
			= new StringBuffer();
		txId.append("[");
		txId.append(System.nanoTime());
		txId.append(" ");
		txId.append(starterName);
		txId.append(" ");
		txId.append(getThreadName());
		txId.append("]");
		
		// put the id into thread local		
		Context.create(txId.toString());
		//txId.

		logger.logStartGlobalTransaction(txId.toString());
		

		
	}
	
	after():targetMethod(){
		// flush log
		String txId = (String)Context.local.get();
		logger.logEndGlobalTransaction(txId);
		// clear traction id
		Context.clear();

		
	}
	
	
}
